/* massXpert - the true massist's program.
   --------------------------------------
   Copyright(C) 2006,2007 Filippo Rusconi

   http://www.massxpert.org/massXpert

   This file is part of the massXpert project.

   The massxpert project is the successor to the "GNU polyxmass"
   project that is an official GNU project package(see
   www.gnu.org). The massXpert project is not endorsed by the GNU
   project, although it is released ---in its entirety--- under the
   GNU General Public License. A huge part of the code in massXpert
   is actually a C++ rewrite of code in GNU polyxmass. As such
   massXpert was started at the Centre National de la Recherche
   Scientifique(FRANCE), that granted me the formal authorization to
   publish it under this Free Software License.

   This software is free software; you can redistribute it and/or
   modify it under the terms of the GNU  General Public
   License version 3, as published by the Free Software Foundation.
   

   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this software; if not, write to the

   Free Software Foundation, Inc.,

   51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
*/


#ifndef PEAK_CENTROID_HPP
#define PEAK_CENTROID_HPP


/////////////////////// Qt includes
#include <QtGlobal>
#include <QtXml>


/////////////////////// Local includes


namespace massXpert
{

  class PeakCentroid 
  {
  protected:
    // m/z ratio.
    double m_mz;
    
    // Relative intensity of this peak with respect to all the others
    // in the pattern.
    double m_relativeIntensity;
  
    // Probability of occurrence.
    double m_probability;

  public:
    PeakCentroid(double /* mz */,
                 double /* relIntensity */,
                 double /* probability */);
    PeakCentroid(const PeakCentroid &);
    
    ~PeakCentroid();
    
    PeakCentroid * clone() const;
    void clone(PeakCentroid *) const;
    void mold(const PeakCentroid &);
    PeakCentroid & operator =(const PeakCentroid &);
    
    void setMz(double);
    double mz() const;
    
    void setProbability(double);
    void incrementProbability(double);
    double probability() const;
    QString probability(const QLocale &, int = 10) const;
  
    void setRelativeIntensity(double);
    double relativeIntensity() const;
    QString relativeIntensity(const QLocale &, int = 10) const;
  };
  
} // namespace massXpert


#endif // PEAK_CENTROID_HPP

